#include "netrun.h"

/*
 * Mostly do_this functions so small they don't warrant a seperate section. 
 * In the end, the only ones here should really be do_quit and do_main.
 */

/*
 * Do main-menu sort of things - load and save games, start new games, and
 * quit.  The boolean starting_up indicates whether or not this has been
 * called from main(), and thus if the user should be allowed to use the
 * 'back out' command.
 */
void do_start(void)
{
    if (!load_game())
        create_game();
    
    where = W_HOME;

    return;
}

/*
 * Start a new game.
 */
 
void create_game(void)
{
    create_netspace();
     
    runner = new_runner_data();

    /* Get the runner's name and strcpy it. */
    strncpy(runner->name, input_long("So what's your name, choomba?"), sizeof(runner->name)); /* HACK */
    
    /* UNFIN the starting gear is more for testing rather than playing. */
    program_to_deck(runner, create_program(find_prog(P_STEALTH ,1)));
    program_to_deck(runner, create_program(find_prog(P_ANTI_P, 1)));
    program_to_deck(runner, create_program(find_prog(P_DECR, 1)));
    program_to_deck(runner, create_program(find_prog(P_INTR, 1)));
    
    /* TODO Explanation, more story. */

    runner->meat = MAX_MEAT;
    runner->rom = MAX_ROM;    
    runner->credits = 1000;

    runner->net_x = start_net_x;
    runner->net_y = start_net_y;
                  
    event("You haul on your gear, and set off for your new house - a %s.",
        house_name_table[runner->rank]);
}

/* Nightly maintenance sort of thing. */
/* HACK UNFIN This is _supposed_ to be called _only_ in an all-player maintanence mode, not by any player action. Don't use it. */
void next_day(RUNNER_DATA * pRunner)
{
    /* UNFIN Roll randomly for a special event. These occur ~1 day in 10, and have mild effect. */

    event("You have %s for dinner, and go to sleep.",
        food_name_table[pRunner->rank]);

    /* UNFIN do night special events */
                
    event("You yawn, stretch and get up. You have %s for breakfast.\n",
        food_name_table[pRunner->rank]);
    
    /* UNFIN do morning special events */

    {
        int interest;
        int loan_interest;

        /* Calculate interest on deposited credits. */
            
        interest = pRunner->deposit;
        interest *= INTEREST;
        interest /= 100;
        
        if (interest > 0)
        {
            event("Your bank account has picked up %dcr in interest.",
                interest);
            pRunner->deposit += interest;    
        }
    
            
        /* Calculate interest on loan */
            
        loan_interest = pRunner->loan;
        loan_interest *= LOAN_INTEREST;
        loan_interest /= 100;
        
        if (loan_interest > 0)
        {
            event("%sour loan has picked up %dcr in interest.",
                (interest) ? "However, y" : "Y",
                interest);
            pRunner->loan += interest;    
        }
    }
    
    /* UNFIN calculate bank fees - daily charge */

/* Not needed - record date started playing instead.
    pRunner->days++;
*/
    
    display_player(pRunner);
    morewait();                 
}



















