
/* This file was generated with:
`cfunctions -g global bank.c core.c display.c do_misc.c ice.c input.c main.c 
memory.c misc.c movement.c netspace.c output.c programs.c random.c running.c 
saved.c server.c tables.c utils.c' */
#ifndef CFH_GLOBAL_H
#define CFH_GLOBAL_H

/* From `bank.c': */
void do_bank (RUNNER_DATA * pRunner );
void do_bank_cheque (RUNNER_DATA * pRunner );
void do_bank_deposit (RUNNER_DATA * pRunner );
void do_bank_withdraw (RUNNER_DATA * pRunner );
void do_bank_loan (RUNNER_DATA * pRunner );
int networth (RUNNER_DATA * pRunner );
/* From `core.c': */
void do_street (RUNNER_DATA * pRunner );
void do_home (RUNNER_DATA * pRunner );
void do_sellinfo (RUNNER_DATA * pRunner );
void do_programs_buy (RUNNER_DATA * pRunner );
void do_programs_buy_aux (RUNNER_DATA * pRunner , program_type type );
void do_programs_sell (RUNNER_DATA * pRunner );
void do_deck (RUNNER_DATA * pRunner );
void do_deck_up (RUNNER_DATA * pRunner );
void do_deck_down (RUNNER_DATA * pRunner );
void do_deck_rom (RUNNER_DATA * pRunner );
void do_day_rank (RUNNER_DATA * pRunner );
void do_day_heal (RUNNER_DATA * pRunner );
void do_startrun (RUNNER_DATA * pRunner );
void do_other_insert (RUNNER_DATA * pRunner );
void do_other_remove (RUNNER_DATA * pRunner );
/* From `display.c': */
void splash_screen (void);
void display_player (RUNNER_DATA * pRunner );
void display_stored_programs (RUNNER_DATA * pRunner );
void display_deck_programs (RUNNER_DATA * pRunner );
char * duration_str (PROGRAM_DATA * pProgram );
void display_running (RUNNER_DATA * pRunner );
void display_room (int x , int y );
void display_net_space (RUNNER_DATA * pRunner );
void disp_netspace (RUNNER_DATA * pRunner , int x , int y );
void show_room (RUNNER_DATA * pRunner );
void show_netspace (RUNNER_DATA * pRunner );
void show_netspace_aux (NETSPACE_DATA * pNetspace , const char * where );
SERVER_LEVEL_LIST * server_level_name (int level );
void display_running_menu (RUNNER_DATA * pRunner );
void display_programs_running (RUNNER_DATA * pRunner );
void show_stats (RUNNER_DATA * pRunner );
/* From `do_misc.c': */
void do_start (void);
void create_game (void);
void next_day (RUNNER_DATA * pRunner );
/* From `ice.c': */
ICE_MASTER * find_ice (ice_full_type fulltype , int str );
ICE_DATA * create_ice (ICE_MASTER * pMaster );
ICE_TYPE_LIST * get_ice_type (ice_full_type fulltype );
char * ice_long (ICE_DATA * pIce );
void ice_anti_program (RUNNER_DATA * pRunner , ICE_DATA * pIce );
void ice_anti_deck (RUNNER_DATA * pRunner , ICE_DATA * pIce );
void ice_anti_user (RUNNER_DATA * pRunner , ICE_DATA * pIce );
int prot_bonus (RUNNER_DATA * pRunner );
/* From `input.c': */
char * input_long (char * fmt , ... );
char * input (char * fmt , ... );
bool yn (char * fmt , ... );
int input_num (int llimit , int ulimit , char * fmt , ... );
PROGRAM_DATA * input_stored_program (RUNNER_DATA * pRunner , char * question );
PROGRAM_DATA * input_deck_program (RUNNER_DATA * pRunner , char * question );
int input_direction (char * fmt , ... );
/* From `main.c': */
extern RUNNER_DATA * runner;
extern SERVER_DATA * server;
extern running_state next_action;
extern where_state where;
extern WINDOW * title;
extern WINDOW * display;
extern WINDOW * programs;
extern WINDOW * menus;
extern WINDOW * descs;
extern WINDOW * errs;
extern WINDOW * inputs;
extern WINDOW * bottom;
extern WINDOW * player_stats;
extern int server_x;
extern int server_y;
extern bool running;
extern int net_size_x;
extern int net_size_y;
extern NETSPACE_DATA * * netspace;
extern int start_net_x;
extern int start_net_y;
extern FILE * pLog;
extern WINDOW * pr_window;
extern char * save_file;
void exit_properly (void);
/* From `memory.c': */
void * alloc_mem (size_t size );
void * calloc_mem (size_t nmemb , size_t size );
void free_mem (void * ptr );
PROGRAM_DATA * new_program_data (void);
void free_program_data (PROGRAM_DATA *pProgram );
ICE_DATA * new_ice_data (void);
void free_ice_data (ICE_DATA *pIce );
ROOM_DATA * new_room_data (void);
void free_room_data (ROOM_DATA * pRoom );
SERVER_DATA * new_server_data (void);
void free_server_data (SERVER_DATA * pServer );
RUNNER_DATA * new_runner_data (void);
void free_runner_data (RUNNER_DATA * pRunner );
TXT_GRID * new_txt_grid (void);
void free_txt_grid (TXT_GRID * pGrid );
/* From `misc.c': */
extern char backslashstring[];
void morewait (void);
void running_on (void);
void running_off (void);
char * word_wrap (const char * left_hanging , const char * left_indent , const char * input , const int line_length );
char * cline (char * message , char * lbracket , char * rbracket , char * dash , int width );
/* From `movement.c': */
void do_running_move (RUNNER_DATA * pRunner , int direction );
bool check_move (int x , int y , int dir );
bool ice_check (void);
bool stealth_check (RUNNER_DATA * pRunner );
int stealth_bonus (RUNNER_DATA * pRunner );
PROGRAM_DATA * best_stealth (RUNNER_DATA * pRunner );
/* From `netspace.c': */
void do_netspace (RUNNER_DATA * pRunner );
NETSPACE_DATA * net_space (int x , int y , int direction );
NETSPACE_DATA * net_space_aux (int x , int y );
void do_netspace_move (RUNNER_DATA * pRunner , int dir );
void do_netspace_jack (RUNNER_DATA * pRunner );
void enter_server (RUNNER_DATA * pRunner , NETSPACE_DATA * pNetspace );
void create_netspace (void);
int netspace_level (NETSPACE_DATA * pNetspace );
void alloc_netspace (void);
/* From `output.c': */
void menu_init (void);
void menu (char * key , char * fmt , ... );
void menu_print (void);
void err_blank (void);
void err (char * fmt , ... );
void event (char * fmt , ... );
void bug (char * fmt , ... );
void log (char * fmt , ... );
extern char desc_buf[];
void desc (char * fmt , ... );
void desc_clear (void);
void stat (char * fmt , ... );
void init_output (void);
void stop_output (void);
void pr_pick (WINDOW * win );
void pr_blank (void);
void prm (int y , int x );
void prd (int y2 , int x2 );
void pr (char * fmt , ... );
void prc (chtype ch );
void rch (int count , chtype ch );
void pr_print (void);
void pr_paint (void);
/* From `programs.c': */
PROGRAM_MASTER * find_prog (program_full_type fulltype , int str );
PROGRAM_DATA * create_program (PROGRAM_MASTER * pMaster );
PROGRAM_TYPE_LIST * get_type (program_full_type fulltype );
bool strength_check (PROGRAM_DATA * pProgram );
int num_stored_programs (RUNNER_DATA * pRunner );
int size_programs (RUNNER_DATA * pRunner );
int program_size (PROGRAM_DATA * pProgram );
void remove_program (RUNNER_DATA * pRunner , PROGRAM_DATA * pRemove );
void program_to_deck (RUNNER_DATA * pRunner , PROGRAM_DATA * pAdd );
void program_to_stored (RUNNER_DATA * pRunner , PROGRAM_DATA * pAdd );
void program_anti (RUNNER_DATA * pRunner , PROGRAM_DATA * pProgram );
void program_intr (RUNNER_DATA * pRunner , PROGRAM_DATA * pProgram );
void program_decr (RUNNER_DATA * pRunner , PROGRAM_DATA * pProgram );
void program_prot (RUNNER_DATA * pRunner , PROGRAM_DATA * pProgram );
void program_stealth (RUNNER_DATA * pRunner , PROGRAM_DATA * pProgram );
void program_info (RUNNER_DATA * pRunner , PROGRAM_DATA * pProgram );
void program_cred (RUNNER_DATA * pRunner , PROGRAM_DATA * pProgram );
void program_no_use_netspace (RUNNER_DATA * pRunner , PROGRAM_DATA * pProgram );
/* From `random.c': */
int dice (int number , int type );
int one_in_ (int j );
int number_range (int from , int to );
void init_random (void);
/* From `running.c': */
void stop_run (RUNNER_DATA * pRunner );
void do_running (RUNNER_DATA * pRunner );
void do_ice (RUNNER_DATA * pRunner );
void do_running_runner (RUNNER_DATA * pRunner );
void do_running_runner_run (RUNNER_DATA * pRunner );
void do_running_runner_copy (RUNNER_DATA * pRunner );
void do_running_runner_delete (RUNNER_DATA * pRunner );
void do_running_runner_jack (RUNNER_DATA * pRunner );
void do_running_next (RUNNER_DATA * pRunner );
/* From `saved.c': */
bool load_game (void);
void save_game (void);
void write_game (char * filename );
bool read_game (char * filename );
void write_runner (FILE * fp );
void read_runner (RUNNER_DATA * pRunner , FILE * fp );
void write_program (PROGRAM_DATA * pProgram , FILE * fp );
PROGRAM_DATA * read_program (FILE * fp );
void write_netspace (FILE * fp );
void read_netspace_type (FILE * fp );
void read_netspace_initial (FILE * fp );
TXT_GRID * read_txt_grid (FILE * fp );
const char * write_program_full_type (PROGRAM_DATA * pProgram );
program_full_type fread_program_full_type (FILE * fp );
char write_netspace_type (netspace_type type );
netspace_type read_netspace_type_aux (char name );
char * find_initial (char initial , int level );
char * fread_string (FILE * fp );
char * print_flags (int flag );
int fread_number (FILE *fp );
long fread_flag (FILE *fp );
long flag_convert (char letter );
void fread_to_eol (FILE *fp );
char * fread_wordc (FILE * fp );
char * fread_word (FILE *fp );
char * fread_hword (FILE * fp );
/* From `server.c': */
ROOM_DATA * room (int x , int y , int direction );
ROOM_DATA * room_aux (int x , int y );
SERVER_DATA * init_server (int level , char * name );
void assign_spoils (ROOM_DATA * pRoom , int level );
void assign_ice (ROOM_DATA * pRoom , int level );
/* From `tables.c': */
extern const char * server_names[][MAX_NAMES];
extern const int server_spoils_table[];
extern const ICE_MASTER ice_table[];
extern const ICE_TYPE_LIST ice_type_list[];
extern const int program_size_table[];
extern const int program_cost_table[];
extern const int armor_cost_table[];
extern const char * rank_name_table[];
extern const int rank_cost_table[];
extern const char * house_name_table[];
extern const char * food_name_table[];
extern const char * car_name_table[];
extern const char * dir_name_table[];
extern const util_type util_table[];
extern const char layout_table[][MAX_ROOMS_X][MAX_ROOMS_Y];
extern const PROGRAM_MASTER program_list[];
extern const PROGRAM_TYPE_LIST program_type_list[];
extern const NETSPACE_TYPE_LIST netspace_type_list[];
extern const char netspace_layout[][17];
extern const SERVER_LEVEL_LIST server_level_list[];
/* From `utils.c': */
void do_utils (RUNNER_DATA * pRunner );
char * utilities (RUNNER_DATA * pRunner );
void util_repair (RUNNER_DATA * pRunner );
void util_virusscan (RUNNER_DATA * pRunner );
void util_antivirus (RUNNER_DATA * pRunner );
void util_news (RUNNER_DATA * pRunner );
void util_rankings (RUNNER_DATA * pRunner );

#endif /* CFH_GLOBAL_H */
