#include "netrun.h"
/* *printf *sigh* */
#include <stdio.h>

ICE_MASTER * find_ice(ice_full_type fulltype, int str)
{
    int i;
    
    i = 0;
    
    while(ice_table[i].name != NULL)
    {
        if (ice_table[i].fulltype == fulltype)
        {
            if (ice_table[i].str == str)
            {
                return &ice_table[i];
            }
        }
        
        i++;
    }
    
    return NULL;
}


ICE_DATA * create_ice(ICE_MASTER * pMaster)
{
    ICE_DATA * pIce;
    
    if (pMaster == NULL)
        return NULL;
    
    pIce = new_ice_data();
    
    pIce->name = pMaster->name;
    pIce->action = pMaster->action;
    pIce->thr = get_ice_type(pMaster->fulltype)->thr;
    pIce->type = get_ice_type(pMaster->fulltype)->type;
    pIce->fulltype = pMaster->fulltype;
    pIce->str = pMaster->str;
    pIce->max_str = pMaster->str;
    
    return pIce;
}

ICE_TYPE_LIST * get_ice_type(ice_full_type fulltype)
{
    int i;
    
    i = 0;
    
    while(ice_type_list[i].run != NULL)
    {
        if (ice_type_list[i].fulltype == fulltype)
        {
            return &ice_type_list[i];
        }
        
        i++;
    }
    
    return NULL;
}

/*
 * Return a name of a server program, complete with '(STR 1/1 A-P)'.
 */

char *ice_long(ICE_DATA * pIce)
{
    static char buf[100];

    sprintf(buf, "%s (STR %d/%d %s)",
        pIce->name,
        pIce->str,
        pIce->max_str,
        pIce->thr);

    return buf;
}

/*
 * Running server programs
 */

void ice_anti_program(RUNNER_DATA * pRunner, ICE_DATA * pIce)
{
    PROGRAM_DATA * pProgram;
    int attack, defense;    
    
    if (pRunner->last_run != NULL)    
        pProgram = pRunner->last_run;
    /* Hopefully this will make it attack running programs (duration) if the runner didn't run a program this turn. */    
    else    
    {        
        PROGRAM_DATA * pBest;
        /* Cleaner-looking anti-NULL->str fix. */
        int bonus;
        
        pProgram = pRunner->programs;
        pBest = NULL;
        bonus = 0;
        
        while(pProgram != NULL)
        {
            if (pProgram->duration > 0)
            {
                if ((pProgram->str - pProgram->virus) > bonus)
                {
                    pBest = pProgram;
                    bonus = (pBest->str - pBest->virus);
                }                    
            }
            
            pProgram = pProgram->next;
        }
        
        pProgram = pBest;        
    }

    if (pProgram == NULL)
    {
        desc("The %s glares at you, having nothing to attack.\n",
            pIce->name);
        set_next(ST_NEXT);
        return;
    }

    attack = pIce->str + server->level + dice(1, 10);
    defense = (pProgram->str - pProgram->virus) + pRunner->rank + dice(1, 10) + rom_penalty();

    {
        /* HACK */
        char buf[100];

        sprintf(buf, "%s runs. %s ",
            pIce->name,
            pIce->action);

        desc(buf, pProgram->name);
    }

    if (attack >= defense)
    {
        int dam;

        dam = dice(1, 6);

        if (pProgram->str - dam < 1)
        {
/* Only very few ICE can actually _destroy_ a program...
            desc("Your %s is destroyed!\n",
                program_short(pProgram));
            kill_program(pProgram);            
*/
            desc("Your %s is knocked out!\n",
                pProgram->name);
            
            pProgram->str = 0;
        }
        else
        {
            pProgram->str -= dam;
            desc("Your %s is now STR %d/%d.\n",
                pProgram->name,
                pProgram->str,
                pProgram->max_str);

        }

        /* Attacked programs cut out. */    
        /* This means that when the end-of-turn rolls around, it gets closed. */
        if (pProgram->duration > 0)
            pProgram->duration = 1;    
    }
    else
    {
        desc("Your %s is unharmed.\n",
            pProgram->name);
    }

    morewait();    
    set_next(ST_NEXT);
}

void ice_anti_deck(RUNNER_DATA * pRunner, ICE_DATA * pIce)
{
    int attack, defense;

    attack = pIce->str + server->level + dice(1, 10);
    defense = prot_bonus(pRunner) + pRunner->armor + dice(1, 10) + rom_penalty();

    desc("The %s runs. %s ",
        pIce->name,
        pIce->action);

    if (attack >= defense)
    {
        int dam;

        dam = dice(1, 6);

        if (pRunner->rom - dam < 1)
        {
            desc("Your deck's ROM is destroyed!\n");
            desc("Your connection drops out with a sickening lurch of static.");
            pRunner->rom = 0;
            stop_run(pRunner);
            where = W_HOME;
            running_off();
            return;
        }
        else
        {
            pRunner->rom -= dam;
            desc("Your deck now has %d/%d ROM pts.\n",
                pRunner->rom,
                MAX_ROM);
        }
    }
    else
    {
        desc("Your deck is unharmed.\n");

    }

    morewait();
    set_next(ST_NEXT);
}

void ice_anti_user(RUNNER_DATA * pRunner, ICE_DATA * pIce)
{
    int attack, defense;

    attack = pIce->str + server->level + dice(1, 10);
    defense = prot_bonus(pRunner) + pRunner->armor + pRunner->rank + dice(1, 10) + rom_penalty();

    desc("The %s runs. %s ",
        pIce->name,
        pIce->action);

    if (attack >= defense)
    {
        int dam;

        dam = dice(1, 6);

        if (pRunner->meat - dam < 1)
        {
            desc("You die!...\n");
            /* UNFIN got to implement going back to main menu after losing. */
            desc("Your connection drops out with a sickening lurch of static.");
            stop_run(pRunner);
            where = W_HOME;
            running_off();
            return;
            /* HACK they don't die!... */
        }
        else
        {
            pRunner->meat -= dam;
            desc("You now have %d/%d meat pts left.\n",
                pRunner->meat,
                MAX_MEAT);
        }
    }
    else
    {
        desc("You are unharmed.\n");
    }

    morewait();
    set_next(ST_NEXT);
}

int prot_bonus(RUNNER_DATA * pRunner)
{
    PROGRAM_DATA * pProgram;
    int bonus;
    
    bonus = 0;
    pProgram = pRunner->programs;
    
    while(pProgram != NULL)
    {
        if (pProgram->type == P_PROT)
        {
            if (pProgram->duration > 0)
            {
                if ((pProgram->str - pProgram->virus) > bonus)
                    bonus = (pProgram->str - pProgram->virus);
            }
        }
        
        pProgram = pProgram->next;        
    }
    
    return bonus;
}


