#include "netrun.h"

void do_utils(RUNNER_DATA * pRunner)
{
    int choice;
    bool repeat;
    int i;            
    
    repeat = TRUE;
    while(repeat)
    {
        menu_init();
        {
            i = 0;
            
            menu("","Utilities    Cost Got?");
            
            while(util_table[i].name != NULL)
            {
                /* HACK */
                char buf[100];
                
                sprintf(buf, "%2d", i + 1);
                
                menu(buf, "%12s %4d [%c]",
                    util_table[i].name,
                    util_table[i].cost,
                    (has_util(util_table[i].bit) ? '*': ' '));
                
                i++;
            }                        
        }
        
        menu_print();
        stat(
            " * Cash: %ldcr ROM: %1d/%1d Meat: %1d/%1d",
            pRunner->credits,
            pRunner->rom, MAX_ROM,
            pRunner->meat, MAX_MEAT);
                
        choice = input_num(1, i, "Trade which util?");
        
        if (choice < 1)
        {
            return;
        }
        
        if (has_util(util_table[choice - 1].bit))
        {
            if (yn("Sell your copy of the %s util for %dcr?",
                util_table[choice - 1].name,
                UMAX(1, util_table[choice - 1].cost / 2)))
            {
                event("You sell your copy of the %s util for %dcr.",
                    util_table[choice - 1].name,
                    UMAX(1, util_table[choice - 1].cost / 2));
                
                pRunner->credits += (UMAX(1, util_table[choice - 1].cost / 2));
                remove_util(util_table[choice - 1].bit);                
            }            
        }
        else
        {
            if (pRunner->credits < util_table[choice - 1].cost)        
            {
                err("A copy of the %s util costs %dcr, which you can't afford.",
                    util_table[choice - 1].name,
                    util_table[choice - 1].cost);
            }
            else if (yn("A copy of the %s util costs %dcr. Buy it?",
                util_table[choice - 1].name,
                util_table[choice - 1].cost))
            {
                event("You buy a copy of the %s util for %dcr.",
                    util_table[choice - 1].name,
                    util_table[choice - 1].cost);
                
                pRunner->credits -= (util_table[choice - 1].cost);                
                add_util(util_table[choice - 1].bit);                
            }            
        }
    }
    
    return;
}

/* Possible bug: what if the player has utilities, but none are on the util_table? */
char * utilities(RUNNER_DATA * pRunner)
{

    if (pRunner->utils == 0)
    {
        return " (none)";
    }
    else 
    {
        static char buf[200];    
        int i;
        
        buf[0] = '\0';
        i = 0;
        
        while(util_table[i].name != NULL)
        {
            if (has_util(util_table[i].bit))
            {
                /* HACK */
                strcat(buf, " ");
                strcat(buf, util_table[i].name);
            }
            
            i++;
        }

        return buf; 
    }
}


/* Called after jacking out. */
void util_repair(RUNNER_DATA * pRunner)
{
    bool used;
    PROGRAM_DATA * pProgram;

    if (!has_util(UTIL_REPAIR))
        return;
        
    used = FALSE;
    
    pProgram = pRunner->stored;
    
    while ( pProgram != NULL )    
    {
        if (pProgram->str != pProgram->max_str)
        {
            pProgram->str = pProgram->max_str;
            used = TRUE;
        }
        
        if (pProgram->duration != 0)
        {
            pProgram->duration = 0;
            used = TRUE;
        }
        
        pProgram = pProgram->next;
    }
    
    pProgram = pRunner->programs;
    
    while ( pProgram != NULL )
    {
        if (pProgram->str != pProgram->max_str)
        {
            pProgram->str = pProgram->max_str;
            used = TRUE;
        }

        if (pProgram->duration != 0)
        {
            pProgram->duration = 0;
            used = TRUE;
        }
        
        pProgram = pProgram->next;
    }
    
    if (used)
    {
        event("You spend a few minutes using the Repair utility on your damaged programs.");
        event("All of your surviving programs have been fully restored.");
    }
        
}

/* UNFIN When do we call this? */
void util_virusscan(RUNNER_DATA * pRunner)
{
    PROGRAM_DATA * pProgram;
    
    if (!has_util(UTIL_VIRUSSCAN))
        return;

    pProgram = pRunner->programs;
    
    while ( pProgram != NULL )
    {
        if (pProgram->virus)
        {
            /* UNFIN _Really_ bad way of showing this. Think display_deck_programs -> display_infected_programs. */
            event("Your %s is infected.",
                pProgram->name);
        }
    
        pProgram = pProgram->next;
    }        

    pProgram = pRunner->stored;
    
    while ( pProgram != NULL )
    {
        if (pProgram->virus)
        {
            /* UNFIN _Really_ bad way of showing this. Think display_deck_programs -> display_infected_programs. */
            event("Your %s is infected.",
                pProgram->name);
        }
    
        pProgram = pProgram->next;
    }
    
    util_antivirus(pRunner);
    
    return;        
}

/* UNFIN When do we call this? */
void util_antivirus(RUNNER_DATA * pRunner)
{
    PROGRAM_DATA * pProgram;
    bool used;

    if (!has_util(UTIL_ANTIVIRUS))
        return;
    
    used = FALSE;
    
    pProgram = pRunner->programs;
    
    while ( pProgram != NULL )
    {
        if (pProgram->virus)
        {
            pProgram->virus = 0;    
            used = TRUE;
        }
    
        pProgram = pProgram->next;
    }        

    pProgram = pRunner->stored;
    
    while ( pProgram != NULL )
    {
        if (pProgram->virus)
        {
            pProgram->virus = 0;    
            used = TRUE;
        }
    
        pProgram = pProgram->next;
    }
    
    if (used)
    {
        event("Your infected programs have been cleaned.");
    }
    
    return;        
}

/* Daily News - ranking upgrades, deaths, stuff like that. */
/* UNFIN When to call? */
/* UNFIN No news to speak of. It involves files and file locking, at least. */
void util_news(RUNNER_DATA * pRunner)
{
    if (!has_util(UTIL_NEWS))
        return;
    
    event("No news is good news, especially when it isn't finished.");
}

/* Name, networth, rank, days played, and total score of other players. Easiest method is to rewrite a global file and spew it out here. */
/* UNFIN When to call? */
void util_rankings(RUNNER_DATA * pRunner)
{
    if (!has_util(UTIL_RANKINGS))
        return;
    
    event("No other players, let alone rankings.");
}
    
   
        
